%bcond_with amt
%bcond_with azure
%bcond_with kubevirt

%global __os_install_post %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompilespace:.*$!!g')

Summary: Set of unified programs capable of host isolation ("fencing")
Name: fence-agents
Version: 4.12.1
Release: 6%{?dist}
License: GPL-2.0-or-later AND LGPL-2.0-or-later
URL: https://github.com/ClusterLabs/fence-agents
Source0: https://fedorahosted.org/releases/f/e/fence-agents/%{name}-%{version}.tar.gz

%global allfenceagents %(cat <<EOF
fence-agents-alom \\
fence-agents-apc \\
fence-agents-apc-snmp \\
fence-agents-aws \\
fence-agents-bladecenter \\
fence-agents-brocade \\
fence-agents-cdu \\
fence-agents-cisco-mds \\
fence-agents-cisco-ucs \\
fence-agents-cyberpower-ssh \\
fence-agents-docker \\
fence-agents-drac \\
fence-agents-drac5 \\
fence-agents-eaton-snmp \\
fence-agents-ecloud \\
fence-agents-emerson \\
fence-agents-eps \\
fence-agents-gce \\
fence-agents-hds-cb \\
fence-agents-heuristics-ping \\
fence-agents-hpblade \\
fence-agents-ibmblade \\
fence-agents-ibmz \\
fence-agents-ibm-powervs \\
fence-agents-ibm-vpc \\
fence-agents-ifmib \\
fence-agents-ilo-moonshot \\
fence-agents-ilo-mp \\
fence-agents-ilo-ssh \\
fence-agents-ilo2 \\
fence-agents-intelmodular \\
fence-agents-ipdu \\
fence-agents-ipmilan \\
fence-agents-kdump \\
fence-agents-ldom \\
fence-agents-lpar \\
fence-agents-mpath \\
fence-agents-netio \\
fence-agents-ovh \\
fence-agents-redfish \\
fence-agents-rhevm \\
fence-agents-rsa \\
fence-agents-rsb \\
fence-agents-sanbox2 \\
fence-agents-sbd \\
fence-agents-scsi \\
fence-agents-vbox \\
fence-virt \\
fence-agents-vmware \\
fence-agents-vmware-rest \\
fence-agents-vmware-soap \\
fence-agents-vmware-vcloud \\
fence-agents-wti \\
fence-agents-xenapi \\
fence-agents-zvm \\

EOF)

%ifarch x86_64 ppc64le
%global allfenceagents %(cat <<EOF
%{allfenceagents} \\
fence-agents-compute \\
fence-agents-ironic \\
fence-agents-openstack

EOF)
%endif

%global allfenceagents %(cat <<EOF
%{allfenceagents} \\
fence-agents-aws \\
fence-agents-gce

EOF)

BuildRequires: flex bison libuuid-devel systemd-units
BuildRequires: openwsman-python3 corosynclib-devel libvirt-devel libxml2-devel nss-devel nspr-devel
BuildRequires: python3-devel python3-httplib2 python3-pexpect python3-pycurl python3-requests python3-suds
BuildRequires: autoconf automake libtool make gcc libxslt



%prep
%autosetup -n %{name}-%{version} -p1
sed -i.orig 's|FENCE_ZVM=1|FENCE_ZVM=0|' configure.ac

%build
export PYTHON="%{__python3}"

./autogen.sh
%configure \
       SYSTEMD_TMPFILES_DIR=%{_tmpfilesdir} \
       --with-fencetmpdir=/run/fence-agents

%make_build

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}
mkdir -p %{buildroot}/%{_unitdir}/
install -m 0644 agents/virt/fence_virtd.service %{buildroot}/%{_unitdir}/
%py_byte_compile %{__python3} %{buildroot}%{_datadir}/fence

chmod 0755 %{buildroot}%{_datadir}/fence/*.py
rm -rf %{buildroot}/usr/share/doc/fence-agents
rm -f %{buildroot}/%{_libdir}/%{name}/*.*a
rm -f %{buildroot}/%{_libdir}/fence-virt/*.*a

%post
ccs_update_schema > /dev/null 2>&1 ||:
if [ $1 -eq 1 ] ; then
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%preun
if [ $1 -eq 0 ] ; then
    /bin/systemctl --no-reload disable fence_virtd.service &> /dev/null || :
    /bin/systemctl stop fence_virtd.service &> /dev/null || :
fi

%postun
/bin/systemctl daemon-reload &> /dev/null || :
if [ $1 -ge 1 ] ; then
    /bin/systemctl try-restart fence_virtd.service &> /dev/null || :
fi

%description
A collection of executables to handle isolation ("fencing") of possibly
misbehaving hosts by the means of remote power management, blocking
network, storage, or similar. They operate through a unified interface
(calling conventions) devised for the original Red Hat clustering solution.

%package common
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Common base for Fence Agents
Requires: python3-pexpect python3-pycurl
BuildArch: noarch

%description common
A collection of executables to handle isolation ("fencing") of possibly
misbehaving hosts by the means of remote power management, blocking
network, storage, or similar.

This package contains support files including the Python fencing library.


%package all
License: GPL-2.0-or-later AND LGPL-2.0-or-later AND Apache-2.0
Summary: Set of unified programs capable of host isolation ("fencing")
Requires: %{allfenceagents}
Provides: fence-agents = %{version}-%{release}

%description all
A collection of executables to handle isolation ("fencing") of possibly
misbehaving hosts by the means of remote power management, blocking
network, storage, or similar.

This package serves as a catch-all for all supported fence agents.

%ifarch x86_64
%package aliyun
License: GPL-2.0-or-later AND LGPL-2.0-or-later AND Apache-2.0 AND BSD-3-Clause AND MIT
Group: System Environment/Base
Summary: Fence agent for Alibaba Cloud (Aliyun)
Requires: fence-agents-common >= %{version}-%{release}
Requires: python3-jmespath >= 0.9.0

%description aliyun
The fence-agents-aliyun package contains a fence agent for Alibaba Cloud (Aliyun) instances.
%endif

%package alom
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for SUN ALOM
Requires: openssh-clients
Recommends: telnet
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description alom
Fence agent for SUN ALOM.


%if %{with amt}
%package amt
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Intel AMT devices
Requires: amtterm
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description amt
Fence agent for AMT compatibile devices that are accessed via
3rd party software.


%package amt-ws
License: Apache-2.0
Summary: Fence agent for Intel AMT (WS-Man) devices
Requires: fence-agents-common = %{version}-%{release}
Requires: openwsman-python3
BuildArch: noarch

%description amt-ws
Fence agent for AMT (WS-Man) devices.
%endif


%package apc
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for APC devices
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description apc
Fence agent for APC devices that are accessed via telnet or SSH.


%package apc-snmp
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agents for APC devices (SNMP)
Requires: net-snmp-utils
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description apc-snmp
Fence agents for APC devices that are accessed via the SNMP protocol.


%package aws
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Amazon AWS
Requires: fence-agents-common = %{version}-%{release}
Requires: python3-boto3
BuildArch: noarch

%description aws
Fence agent for Amazon AWS instances.


%if %{with azure}
%package azure-arm
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Azure Resource Manager
Requires: fence-agents-common = %{version}-%{release}
Requires: python3-azure-common
Requires: python3-azure-identity
Requires: python3-azure-mgmt-compute
Requires: python3-azure-mgmt-network
Requires: python3-msrestazure
BuildArch: noarch

%description azure-arm
Fence agent for Azure Resource Manager instances.
%endif


%package bladecenter
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for IBM BladeCenter
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description bladecenter
Fence agent for IBM BladeCenter devices that are accessed
via telnet or SSH.


%package brocade
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Brocade switches
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description brocade
Fence agent for Brocade devices that are accessed via telnet or SSH.


%package cdu
License: GPL-3.0-only
Summary: Fence agent for a Sentry Switch CDU
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description cdu
Fence agent for Sentry Switch CDU power switch.


%package cisco-mds
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Cisco MDS 9000 series
Requires: net-snmp-utils
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description cisco-mds
Fence agent for Cisco MDS 9000 series devices that are accessed
via the SNMP protocol.


%package cisco-ucs
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Cisco UCS series
Requires: python3-pycurl
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description cisco-ucs
Fence agent for Cisco UCS series devices that are accessed
via the SNMP protocol.


%ifarch x86_64 ppc64le
%package compute
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Nova compute nodes
Requires: python3-requests
Requires: python3-novaclient
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description compute
Fence agent for Nova compute nodes.
%endif


%package cyberpower-ssh
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for CyberPower network PDUs
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description cyberpower-ssh


%package docker
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Docker
Requires: python3-pycurl
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description docker
Fence agent for Docker images that are accessed over HTTP.


%package drac
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Dell DRAC
Requires: telnet
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description drac
Fence agent for Dell DRAC IV series devices that are accessed
via telnet.


%package drac5
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Dell DRAC 5
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description drac5
Fence agent for Dell DRAC 5 series devices that are accessed
via telnet or SSH.


%package eaton-snmp
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Eaton network power switches
Requires: net-snmp-utils
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description eaton-snmp
Fence agent for Eaton network power switches that are accessed
via the SNMP protocol.


%package ecloud
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for eCloud and eCloud VPC
Requires: python3-requests
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ecloud
Fence agent for eCloud and eCloud VPC from ANS Group Limited


%package emerson
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Emerson devices (SNMP)
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description emerson
Fence agent for Emerson devices that are accessed via
the SNMP protocol.


%package eps
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for ePowerSwitch 8M+ power switches
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description eps
Fence agent for ePowerSwitch 8M+ power switches that are accessed
via the HTTP(s) protocol.


%package gce
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for GCE (Google Cloud Engine)
Requires: fence-agents-common = %{version}-%{release}
Requires: python3-google-api-client
BuildArch: noarch

%description gce
Fence agent for GCE (Google Cloud Engine) instances.


%package hds-cb
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Hitachi Compute Blade systems
Requires: telnet
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description hds-cb
Fence agent for Hitachi Compute Blades that are accessed via telnet.


%package heuristics-ping
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Pseudo fence agent to affect other agents based on ping-heuristics
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description heuristics-ping
Fence pseudo agent used to affect other agents based on
ping-heuristics.


%package hpblade
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for HP BladeSystem devices
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description hpblade
Fence agent for HP BladeSystem devices that are accessed via telnet
or SSH.


%package ibmblade
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for IBM BladeCenter
Requires: net-snmp-utils
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ibmblade
Fence agent for IBM BladeCenter devices that are accessed
via the SNMP protocol.


%package ibmz
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for IBM z LPARs
Requires: python3-requests
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ibmz
Fence agent for IBM z LPARs that are accessed via the HMC
Web Services REST API.


%package ibm-powervs
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for IBM PowerVS
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ibm-powervs
Fence agent for IBM PowerVS that are accessed via REST API.


%package ibm-vpc
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for IBM Cloud VPC
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ibm-vpc
Fence agent for IBM Cloud VPC that are accessed via REST API.


%package ifmib
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for devices with IF-MIB interfaces
Requires: net-snmp-utils
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ifmib
Fence agent for IF-MIB interfaces that are accessed via
the SNMP protocol.


%package ilo2
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agents for HP iLO2 devices
Requires: gnutls-utils
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ilo2
Fence agents for HP iLO2 devices that are accessed via
the HTTP(s) protocol.


%package ilo-moonshot
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for HP iLO Moonshot devices
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ilo-moonshot
Fence agent for HP iLO Moonshot devices that are accessed
via telnet or SSH.


%package ilo-mp
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for HP iLO MP devices
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ilo-mp
Fence agent for HP iLO MP devices that are accessed via telnet or SSH.


%package ilo-ssh
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agents for HP iLO devices over SSH
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ilo-ssh
Fence agents for HP iLO devices that are accessed via telnet or SSH.


%package intelmodular
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for devices with Intel Modular interfaces
Requires: net-snmp-utils
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description intelmodular
Fence agent for Intel Modular interfaces that are accessed
via the SNMP protocol.


%package ipdu
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for IBM iPDU network power switches
Requires: net-snmp-utils
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ipdu
Fence agent for IBM iPDU network power switches that are accessed
via the SNMP protocol.


%package ipmilan
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agents for devices with IPMI interface
Requires: /usr/bin/ipmitool
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ipmilan
Fence agents for devices with IPMI interface.


%ifarch x86_64 ppc64le
%package ironic
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for OpenStack's Ironic (Bare Metal as a service)
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ironic
Fence agent for OpenStack's Ironic (Bare Metal as a service) service.
%endif


%package kdump
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for use with kdump crash recovery service
Requires: fence-agents-common = %{version}-%{release}

%description kdump
Fence agent for use with kdump crash recovery service.


%if %{with kubevirt}
%package kubevirt
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for KubeVirt platform
Requires: python3-openshift >= 0.12.1
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description kubevirt
Fence agent for KubeVirt platform.
%endif


%package ldom
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Sun LDom virtual machines
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ldom
Fence agent for APC devices that are accessed via telnet or SSH.


%package lpar
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for IBM LPAR
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description lpar
Fence agent for IBM LPAR devices that are accessed via telnet or SSH.


%package mpath
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for reservations over Device Mapper Multipath
Requires: device-mapper-multipath
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description mpath
Fence agent for SCSI persistent reservation over
Device Mapper Multipath.


%package netio
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Koukaam NETIO devices
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description netio
Fence agent for Koukaam NETIO devices that are accessed
via telnet or SSH.


%ifarch x86_64 ppc64le
%package openstack
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for OpenStack's Nova service
Requires: python3-requests
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description openstack
Fence agent for OpenStack's Nova service.
%endif


%package ovh
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for OVH provider
Requires: python3-suds
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description ovh
Fence agent for OVH hosting provider.


%package pve
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for PVE
Requires: python3-pycurl
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description pve
Fence agent for PVE.


%package raritan
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Raritan Dominion PX
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description raritan
Fence agent for Raritan Dominion PX.


%package rcd-serial
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for RCD serial
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description rcd-serial
Fence agent for RCD serial.


%package redfish
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Group: System Environment/Base
Summary: Fence agent for Redfish
Requires: fence-agents-common >= %{version}-%{release}
Requires: python3-requests

%description redfish
The fence-agents-redfish package contains a fence agent for Redfish


%package rhevm
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for RHEV-M
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description rhevm
Fence agent for RHEV-M via REST API.


%package rsa
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for IBM RSA II
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description rsa
Fence agent for IBM RSA II devices that are accessed
via telnet or SSH.


%package rsb
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Fujitsu RSB
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description rsb
Fence agent for Fujitsu RSB devices that are accessed
via telnet or SSH.


%package sanbox2
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for QLogic SANBox2 FC switches
Requires: telnet
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description sanbox2
Fence agent for QLogic SANBox2 switches that are accessed via telnet.


%package sbd
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for SBD (storage-based death)
Requires: sbd
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description sbd
Fence agent for SBD (storage-based death).


%package scsi
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for SCSI persistent reservations
Requires: sg3_utils
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description scsi
Fence agent for SCSI persistent reservations.


%package vbox
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for VirtualBox
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description vbox
Fence agent for VirtualBox dom0 accessed via SSH.


%package virsh
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for virtual machines based on libvirt
Requires: openssh-clients /usr/bin/virsh
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description virsh
Fence agent for virtual machines that are accessed via SSH.


%package vmware
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for VMWare with VI Perl Toolkit or vmrun
Requires: python3-pexpect
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description vmware
Fence agent for VMWare accessed with VI Perl Toolkit or vmrun.


%package vmware-rest
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for VMWare with REST API
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description vmware-rest
Fence agent for VMWare with REST API.


%package vmware-soap
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for VMWare with SOAP API v4.1+
Requires: python3-suds
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description vmware-soap
Fence agent for VMWare with SOAP API v4.1+.


%package vmware-vcloud
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for VMWare vCloud Director
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description vmware-vcloud
Fence agent for VMWare vCloud Director.


%package wti
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for WTI Network power switches
Requires: openssh-clients
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description wti
Fence agent for WTI network power switches that are accessed
via telnet or SSH.


%package xenapi
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for Citrix XenServer over XenAPI
Requires: python3-pexpect
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description xenapi
Fence agent for Citrix XenServer accessed over XenAPI.


%package zvm
License: GPL-2.0-or-later AND LGPL-2.0-or-later
Summary: Fence agent for IBM z/VM over IP
Requires: fence-agents-common = %{version}-%{release}
BuildArch: noarch

%description zvm
Fence agent for IBM z/VM over IP.


%package -n fence-virt
Summary: A pluggable fencing framework for virtual machines
Requires(post):    systemd-sysv systemd-units
Requires(preun):    systemd-units
Requires(postun):    systemd-units

%description -n fence-virt
Fencing agent for virtual machines.


%package -n fence-virtd
Summary: Daemon which handles requests from fence-virt

%description -n fence-virtd
This package provides the host server framework, fence_virtd,
for fence_virt.  The fence_virtd host daemon is resposible for
processing fencing requests from virtual machines and routing
the requests to the appropriate physical machine for action.


%package -n fence-virtd-multicast
Summary:  Multicast listener for fence-virtd
Requires: fence-virtd

%description -n fence-virtd-multicast
Provides multicast listener capability for fence-virtd.


%package -n fence-virtd-serial
Summary:  Serial VMChannel listener for fence-virtd
Requires: libvirt >= 0.6.2
Requires: fence-virtd

%description -n fence-virtd-serial
Provides serial VMChannel listener capability for fence-virtd.


%package -n fence-virtd-tcp
Summary:  TCP listener for fence-virtd
Requires: fence-virtd

%description -n fence-virtd-tcp
Provides TCP listener capability for fence-virtd.


%package -n fence-virtd-libvirt
Summary:  Libvirt backend for fence-virtd
Requires: libvirt >= 0.6.0
Requires: fence-virtd

%description -n fence-virtd-libvirt
Provides fence_virtd with a connection to libvirt to fence
virtual machines.  Useful for running a cluster of virtual
machines on a desktop.


%package -n fence-virtd-cpg
Summary:  CPG/libvirt backend for fence-virtd
Requires: corosynclib
Requires: fence-virtd

%description -n fence-virtd-cpg
Provides fence_virtd with a connection to libvirt to fence
virtual machines. Uses corosync CPG to keep track of VM
locations to allow for non-local VMs to be fenced when VMs
are located on corosync cluster nodes.


%files common
%doc doc/COPYING.* doc/COPYRIGHT doc/README.licence
%{_datadir}/fence
%exclude %{_datadir}/fence/azure_fence.*
%exclude %{_datadir}/fence/XenAPI.*
%{_datadir}/cluster
%exclude %{_datadir}/cluster/fence_mpath_check*
%exclude %{_datadir}/cluster/fence_scsi_check*
%{_datadir}/pkgconfig/%{name}.pc
%exclude %{_sbindir}/*
%exclude %{_mandir}/man8/*
%{_tmpfilesdir}/%{name}.conf
%dir %attr (1755, root, root)  /run/%{name}

%files all

%ifarch x86_64
%files aliyun
%defattr(-,root,root,-)
%{_sbindir}/fence_aliyun
%{_mandir}/man8/fence_aliyun.8*
%endif

%files alom
%{_sbindir}/fence_alom
%{_mandir}/man8/fence_alom.8*

%if %{with amt}
%files amt
%{_sbindir}/fence_amt
%{_mandir}/man8/fence_amt.8*

%files amt-ws
%{_sbindir}/fence_amt_ws
%{_mandir}/man8/fence_amt_ws.8*
%endif

%files apc
%{_sbindir}/fence_apc
%{_mandir}/man8/fence_apc.8*

%files apc-snmp
%{_sbindir}/fence_apc_snmp
%{_mandir}/man8/fence_apc_snmp.8*
%{_sbindir}/fence_tripplite_snmp
%{_mandir}/man8/fence_tripplite_snmp.8*

%files aws
%{_sbindir}/fence_aws
%{_mandir}/man8/fence_aws.8*

%if %{with azure}
%files azure-arm
%{_sbindir}/fence_azure_arm
%{_datadir}/fence/azure_fence.py*
%{_mandir}/man8/fence_azure_arm.8*
%endif

%files bladecenter
%{_sbindir}/fence_bladecenter
%{_mandir}/man8/fence_bladecenter.8*

%files brocade
%{_sbindir}/fence_brocade
%{_mandir}/man8/fence_brocade.8*

%files cdu
%{_sbindir}/fence_cdu
%{_mandir}/man8/fence_cdu.8*

%files cisco-mds
%{_sbindir}/fence_cisco_mds
%{_mandir}/man8/fence_cisco_mds.8*

%files cisco-ucs
%{_sbindir}/fence_cisco_ucs
%{_mandir}/man8/fence_cisco_ucs.8*

%ifarch x86_64 ppc64le
%files compute
%{_sbindir}/fence_compute
%{_sbindir}/fence_evacuate
%{_mandir}/man8/fence_compute.8*
%{_mandir}/man8/fence_evacuate.8*
%endif

%files cyberpower-ssh
%{_sbindir}/fence_cyberpower_ssh
%{_mandir}/man8/fence_cyberpower_ssh.8*

%files docker
%{_sbindir}/fence_docker
%{_mandir}/man8/fence_docker.8*

%files drac
%{_sbindir}/fence_drac
%{_mandir}/man8/fence_drac.8*

%files drac5
%{_sbindir}/fence_drac5
%{_mandir}/man8/fence_drac5.8*

%files eaton-snmp
%{_sbindir}/fence_eaton_snmp
%{_mandir}/man8/fence_eaton_snmp.8*

%files ecloud
%{_sbindir}/fence_ecloud
%{_mandir}/man8/fence_ecloud.8*

%files emerson
%{_sbindir}/fence_emerson
%{_mandir}/man8/fence_emerson.8*

%files eps
%{_sbindir}/fence_eps
%{_mandir}/man8/fence_eps.8*

%files gce
%{_sbindir}/fence_gce
%{_mandir}/man8/fence_gce.8*

%files hds-cb
%{_sbindir}/fence_hds_cb
%{_mandir}/man8/fence_hds_cb.8*

%files heuristics-ping
%{_sbindir}/fence_heuristics_ping
%{_mandir}/man8/fence_heuristics_ping.8*

%files hpblade
%{_sbindir}/fence_hpblade
%{_mandir}/man8/fence_hpblade.8*

%files ibmblade
%{_sbindir}/fence_ibmblade
%{_mandir}/man8/fence_ibmblade.8*

%files ibmz
%{_sbindir}/fence_ibmz
%{_mandir}/man8/fence_ibmz.8*

%files ibm-powervs
%{_sbindir}/fence_ibm_powervs
%{_mandir}/man8/fence_ibm_powervs.8*

%files ibm-vpc
%{_sbindir}/fence_ibm_vpc
%{_mandir}/man8/fence_ibm_vpc.8*

%files ifmib
%{_sbindir}/fence_ifmib
%{_mandir}/man8/fence_ifmib.8*

%files ilo2
%{_sbindir}/fence_ilo
%{_sbindir}/fence_ilo2
%{_mandir}/man8/fence_ilo.8*
%{_mandir}/man8/fence_ilo2.8*

%files ilo-moonshot
%{_sbindir}/fence_ilo_moonshot
%{_mandir}/man8/fence_ilo_moonshot.8*

%files ilo-mp
%{_sbindir}/fence_ilo_mp
%{_mandir}/man8/fence_ilo_mp.8*

%files ilo-ssh
%{_sbindir}/fence_ilo_ssh
%{_mandir}/man8/fence_ilo_ssh.8*
%{_sbindir}/fence_ilo3_ssh
%{_mandir}/man8/fence_ilo3_ssh.8*
%{_sbindir}/fence_ilo4_ssh
%{_mandir}/man8/fence_ilo4_ssh.8*
%{_sbindir}/fence_ilo5_ssh
%{_mandir}/man8/fence_ilo5_ssh.8*

%files intelmodular
%{_sbindir}/fence_intelmodular
%{_mandir}/man8/fence_intelmodular.8*

%files ipdu
%{_sbindir}/fence_ipdu
%{_mandir}/man8/fence_ipdu.8*

%files ipmilan
%{_sbindir}/fence_ipmilan
%{_mandir}/man8/fence_ipmilan.8*
%{_sbindir}/fence_idrac
%{_mandir}/man8/fence_idrac.8*
%{_sbindir}/fence_ilo3
%{_mandir}/man8/fence_ilo3.8*
%{_sbindir}/fence_ilo4
%{_mandir}/man8/fence_ilo4.8*
%{_sbindir}/fence_ilo5
%{_mandir}/man8/fence_ilo5.8*
%{_sbindir}/fence_ipmilanplus
%{_mandir}/man8/fence_ipmilanplus.8*
%{_sbindir}/fence_imm
%{_mandir}/man8/fence_imm.8*

%ifarch x86_64 ppc64le
%files ironic
%{_sbindir}/fence_ironic
%{_mandir}/man8/fence_ironic.8*
%endif

%files kdump
%{_sbindir}/fence_kdump
%{_libexecdir}/fence_kdump_send
%{_mandir}/man8/fence_kdump.8*
%{_mandir}/man8/fence_kdump_send.8*

%if %{with kubevirt}
%files kubevirt
%{_sbindir}/fence_kubevirt
%{_mandir}/man8/fence_kubevirt.8*
%endif

%files ldom
%{_sbindir}/fence_ldom
%{_mandir}/man8/fence_ldom.8*

%files lpar
%{_sbindir}/fence_lpar
%{_mandir}/man8/fence_lpar.8*

%files mpath
%{_sbindir}/fence_mpath
%{_datadir}/cluster/fence_mpath_check*
%{_mandir}/man8/fence_mpath.8*

%files netio
%{_sbindir}/fence_netio
%{_mandir}/man8/fence_netio.8*

%ifarch x86_64 ppc64le
%files openstack
%{_sbindir}/fence_openstack
%{_mandir}/man8/fence_openstack.8*
%endif

%files ovh
%{_sbindir}/fence_ovh
%{_mandir}/man8/fence_ovh.8*

%files pve
%{_sbindir}/fence_pve
%{_mandir}/man8/fence_pve.8*

%files raritan
%{_sbindir}/fence_raritan
%{_mandir}/man8/fence_raritan.8*

%files rcd-serial
%{_sbindir}/fence_rcd_serial
%{_mandir}/man8/fence_rcd_serial.8*

%files redfish
%defattr(-,root,root,-)
%{_sbindir}/fence_redfish
%{_mandir}/man8/fence_redfish.8*

%files rhevm
%{_sbindir}/fence_rhevm
%{_mandir}/man8/fence_rhevm.8*

%files rsa
%{_sbindir}/fence_rsa
%{_mandir}/man8/fence_rsa.8*

%files rsb
%{_sbindir}/fence_rsb
%{_mandir}/man8/fence_rsb.8*

%files sanbox2
%{_sbindir}/fence_sanbox2
%{_mandir}/man8/fence_sanbox2.8*

%files sbd
%{_sbindir}/fence_sbd
%{_mandir}/man8/fence_sbd.8*

%files scsi
%{_sbindir}/fence_scsi
%{_datadir}/cluster/fence_scsi_check
%{_datadir}/cluster/fence_scsi_check_hardreboot
%{_mandir}/man8/fence_scsi.8*

%files vbox
%{_sbindir}/fence_vbox
%{_mandir}/man8/fence_vbox.8*

%files virsh
%{_sbindir}/fence_virsh
%{_mandir}/man8/fence_virsh.8*

%files vmware
%{_sbindir}/fence_vmware
%{_mandir}/man8/fence_vmware.8*

%files vmware-rest
%{_sbindir}/fence_vmware_rest
%{_mandir}/man8/fence_vmware_rest.8*

%files vmware-soap
%{_sbindir}/fence_vmware_soap
%{_mandir}/man8/fence_vmware_soap.8*

%files vmware-vcloud
%{_sbindir}/fence_vmware_vcloud
%{_mandir}/man8/fence_vmware_vcloud.8*

%files wti
%{_sbindir}/fence_wti
%{_mandir}/man8/fence_wti.8*

%files xenapi
%{_sbindir}/fence_xenapi
%{_datadir}/fence/XenAPI.py*
%{_mandir}/man8/fence_xenapi.8*

%files zvm
%{_sbindir}/fence_zvmip
%{_mandir}/man8/fence_zvmip.8*

%files -n fence-virt
%doc agents/virt/docs/*
%{_sbindir}/fence_virt
%{_sbindir}/fence_xvm
%{_mandir}/man8/fence_virt.*
%{_mandir}/man8/fence_xvm.*

%files -n fence-virtd
%{_sbindir}/fence_virtd
%{_unitdir}/fence_virtd.service
%config(noreplace) %{_sysconfdir}/fence_virt.conf
%dir %{_libdir}/fence-virt
%{_libdir}/fence-virt/vsock.so
%{_mandir}/man5/fence_virt.conf.*
%{_mandir}/man8/fence_virtd.*

%files -n fence-virtd-multicast
%{_libdir}/fence-virt/multicast.so

%files -n fence-virtd-serial
%{_libdir}/fence-virt/serial.so

%files -n fence-virtd-tcp
%{_libdir}/fence-virt/tcp.so

%files -n fence-virtd-libvirt
%{_libdir}/fence-virt/virt.so

%files -n fence-virtd-cpg
%{_libdir}/fence-virt/cpg.so


%changelog
* Sun Oct 08 2023 cunshunxia <cunshunxia@tencent.com> - 4.12.1-6
- repack for further upgrade.

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.12.1-5
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Jul 19 2023 Miaojun Dong <zoedong@tencent.com> - 4.12.1-4
- Rebuild for libvirt-9.4.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.12.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.12.1-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 1 2023 Zhao Zhen <jeremiazhao@tencent.com> - 4.12.1-1
- updated fence-agents 4.12.1
- disabled ppc64le temlpy
- bootstrap aws/gce/compute/kubevirt/aliyun agents
- disabled azure temply
- added ecloud agents

* Mon Feb 27 2023 Shuo Wang <abushwang@tencent.com> - 4.11.0-1
- initial build
